/***********************************************************************
*
* Copyright (c) 2021-2022 Barbara Geller and Ansel Sermersheim
*
* This example is free software, released under the BSD 2-Clause license.
* For license details refer to LICENSE provided with this project.
*
* CopperSpice is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* https://opensource.org/licenses/BSD-2-Clause
*
***********************************************************************/

#ifndef SYNTAX_H
#define SYNTAX_H

#include <QRegularExpression>
#include <QSyntaxHighlighter>
#include <QTextCharFormat>
#include <QVector>

class Syntax : public QSyntaxHighlighter
{
   CS_OBJECT(Syntax)

 public:
   Syntax(QTextDocument *document);
   bool processSyntax();

 protected:
   void highlightBlock(const QString &text) override;

 private:
   static QByteArray readJson(QString fileName);

   struct HighlightingRule {
      QRegularExpression pattern;
      QTextCharFormat format;
   };

   QVector<HighlightingRule> highlightingRules;
};

#endif
